> For the complete documentation index, see [llms.txt](https://docs.chainvine.xyz/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.chainvine.xyz/developers/use-cases/link-claimer-referrer.md).

# Link Claimer/Referrer

### **Pre-requisites**

* Implement the SDK's recommended [Cookie Management](broken://pages/uYJ1fJuBmasYY0uEzdmV) approach

### **Best practices**

* In browser environments, fetch the referrer\_id using the getReferrer() method provided by the SDK
* In server environments, supply the referrer directly

### Examples

{% tabs %}
{% tab title="Browser" %}

```typescript
import { ChainvineClient, getReferrer } from '@chainvine/sdk';

const client = new ChainvineClient();

// referrer captured from url parameter and PREVIOUSLY saved with 
// the storeReferrerId() method

const referrer = getReferrer();

const referred_user_wallet = '0x1234567890';

const campaign = {
  id: 'aSlug123'
}

if (referrer) {
  const user = await client.syncUser(referred_user_wallet)
  const res = await user.referral({campaign}).linkReferrer(referrer);
}
```

{% endtab %}

{% tab title="Server" %}

```typescript
import { ChainvineClient } from '@chainvine/sdk';

const client = new ChainvineClient({
    apiKey: '9dj022didj', //your api key <--- IMPORTANT
});

const referrer = 'a user referral code' // <--- provided by your system.

const referred_user_wallet = '0x1234567890';

const campaign = {
  id: 'aSlug123'
}

if (referrer) {
  const user = await client.syncUser(referred_user_wallet)
  const referral = await user.referral({campaign}).linkReferrer(referrer);
}

```

{% endtab %}
{% endtabs %}

### **When you only have the referrer's wallet on hand**

* it is possible to fetch the referrer's ChainVine referreralCode if you only have the referrer's wallet address on hand
* simply call .syncUser with ChainvineClient to retrieve this Identifier from ChainVine

```typescript
import { ChainvineClient } from '@chainvine/sdk';

const client = new ChainvineClient({
    apiKey: '9dj022didj', //your api key <--- IMPORTANT in server-side environments
});

const referred_user_wallet = '0x987654321';

const campaign = {
  id: 'aSlug123'
}

const referrer = await client.syncUser(referred_user_wallet);
const { referralCode } = referrer;

if (referralCode) {
  const user = await client.syncUser(referred_user_wallet)
  const referral = await user.referral({campaign}).linkReferrer(referralCode);
}

```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.chainvine.xyz/developers/use-cases/link-claimer-referrer.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
